<template>
  <q-form
    action="https://some-url.com"
    method="post"
    @submit.prevent="createTask"
    class="q-pa-md"
  >
    <div class="text-h6">
      {{ save_mode == "new" ? "New Task" : "Edit Task" }}

      <q-btn
        v-if="save_mode == 'edit'"
        color="secondary"
        label="New"
        @click="newTaskMode"
        :loading="btn_loading"
        :disable="btn_loading"
      />
    </div>
    <q-input color="green-10" v-model="title" label="Title">
      <template v-slot:prepend>
        <q-icon name="title" />
      </template>
    </q-input>

    <q-input
      color="green-10"
      v-model="description"
      label="Description"
      type="textarea"
      autogrow
    >
      <template v-slot:prepend>
        <q-icon name="description" />
      </template>
    </q-input>

    <q-input color="green-10" v-model="due_date" label="Due Date">
      <template v-slot:prepend>
        <q-icon name="event_available" />
      </template>

      <q-popup-proxy
        @before-show="updateProxy"
        cover
        transition-show="scale"
        transition-hide="scale"
      >
        <q-date v-model="due_date">
          <div class="row items-center justify-end q-gutter-sm">
            <q-btn label="Cancel" color="primary" flat v-close-popup />
            <q-btn
              label="OK"
              color="primary"
              flat
              @click="save"
              v-close-popup
            />
          </div>
        </q-date>
      </q-popup-proxy>
    </q-input>

    <q-input color="green-10" v-model="priority" label="Priority">
      <template v-slot:prepend>
        <q-icon name="low_priority" />
      </template>
    </q-input>

    <div class="q-py-md">
      <q-btn
        color="secondary"
        label="Submit"
        @click="createUpdate"
        :loading="btn_loading"
        :disable="btn_loading"
      />
    </div>
  </q-form>
</template>

<script setup>
import axios from "axios";
import { computed, watch, onMounted, reactive, ref } from "vue";
import { useRoute, useRouter } from "vue-router";

const emit = defineEmits(["close", "unClose"]);
const props = defineProps({
  activeId: String,
  value: {
    require: true,
  },
});

watch(
  () => props.activeId,
  (first, second) => {
    
    showUpdateTaskInfo(props.activeId);
  }
);

let btn_loading = ref(false);

const route = useRoute();

let title = ref();
let description = ref();
let due_date = ref();
let priority = ref();
const date = ref();
let save_mode = ref("new");
function newTaskMode() {
  save_mode.value == "new";
}

// -----------------crud

function createUpdate() {
  // btn_loading.value = true;
  let new_update_data = {
    title: title.value,
    description: description.value,
    due_date: due_date.value,
    priority: priority.value,
    created: new Date(),
    to_do_id: route.params.id,
  };

  if (save_mode.value == "new") {
    axios
      .post(
        "https://todolist-965e6-default-rtdb.firebaseio.com/task.json",
        new_update_data
      )
      .then((response) => {
        emit("getData");
      });
  } else if (save_mode.value == "edit") {
    axios
      .put(
        `https://todolist-965e6-default-rtdb.firebaseio.com/task/${props.activeId}.json`,
        new_update_data
      )
      .then((response) => {
        emit("getData");
      });
  }

  btn_loading.value = false;
  save_mode.value = "new";
  title.value = "";
  description.value = "";
  due_date.value = "";
  priority.value = "";
}

function showUpdateTaskInfo(id) {
  axios
    .get(`https://todolist-965e6-default-rtdb.firebaseio.com/task/${id}.json`)
    .then((response) => {
      save_mode.value = "edit";
      let edit_task = response.data;
      title.value = edit_task.title;
      description.value = edit_task.description;
      due_date.value = edit_task.due_date;
      priority.value = edit_task.priority;
    });
}

// -----------------crud

function updateProxy() {
  due_date.value = date.value;
}
</script>
